<?php

namespace Teknisa\MAN\Factories;

use Doctrine\DBAL\Connection;

class VendProdUnidPesoTipoConsFactory {
    protected $connection;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function find($conditions) {
        $cdfilial  = $conditions['P_CDFILIAL'];
        $cdcaixa   = $conditions['P_CDCAIXA'];
        $cdproduto = $conditions['CDPRODUTO'];

        $params = [
            'P_TCDFILIAL'  => $conditions['TCDFILIAL'],
            'P_TCDCAIXA'   => $conditions['TCDCAIXA'],
            'P_TCDPRODUTO' => $conditions['TCDPRODUTO'],
            'P_CDARVPRODI' => $conditions['CDARVPRODI'],
            'P_CDARVPRODF' => $conditions['CDARVPRODF'],
            'P_DTVENDAINI' => $conditions['P_DTINICIAL'],
            'P_DTVENDAFIN' => $conditions['P_DTFINAL'],
        ];
        
        $qry = "
            SELECT V.CDFILIAL || ' - ' || F.NMFILIAL AS LABELFILIAL,
                    TC.CDTIPOCONS || ' - ' || TC.NMTIPOCONS AS CONSUMIDOR,
                    PR.CDARVPROD AS CODIGO, PR.NMPRODUTO, PR.SGUNIDADE,
                    IT.VRUNITVEND,
                    CASE 
                        WHEN TRIM(PR.IDPESAPROD) = 'S' THEN SUM(1) 
                        ELSE SUM(IT.QTPRODVEND) 
                    END AS QTPRODVEND,
                    SUM(IT.QTPRODVEND) AS PESO,
                    SUM(IT.VRDESITVEND) AS VRDESITVEND,
                    SUM(IT.VRACRITVEND) AS VRACRITVEND,
                    SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL, 0)), 2)) - NVL(IT.VRDESITVEND, 0) + NVL(IT.VRACRITVEND, 0)) AS TOTVENDIDO  
                FROM FILIAL F, VENDA V, ITEMVENDA IT, PRODUTO PR, CONSUMIDOR CO, TIPOCONS TC
                WHERE ((V.CDFILIAL IN ($cdfilial)) OR (:P_TCDFILIAL = 'T'))
                    AND ((V.CDFILIAL||V.CDCAIXA IN ($cdcaixa)) OR (:P_TCDCAIXA = 'T'))
                    AND ((PR.CDARVPROD IN ($cdproduto)) OR (:P_TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :P_CDARVPRODI AND :P_CDARVPRODF))
                    AND (V.DTENTRVENDA BETWEEN :P_DTVENDAINI AND :P_DTVENDAFIN)
                    AND (V.IDSITUVENDA = 'O')
                    AND (V.CDFILIAL = F.CDFILIAL)   
                    AND (IT.CDCAIXA = V.CDCAIXA) 
                    AND (IT.NRSEQVENDA = V.NRSEQVENDA) 
                    AND (IT.CDFILIAL = V.CDFILIAL)
                    AND (PR.CDPRODUTO = IT.CDPRODUTO) 
                    AND (CO.CDCLIENTE(+) = V.CDCLIENTE)
                    AND (CO.CDCONSUMIDOR(+) = V.CDCONSUMIDOR)
                    AND (TC.CDTIPOCONS(+) = CO.CDTIPOCONS)
                GROUP BY V.CDFILIAL, F.NMFILIAL, PR.CDARVPROD, PR.NMPRODUTO, PR.SGUNIDADE,
                        IT.VRUNITVEND, TC.CDTIPOCONS, TC.NMTIPOCONS, PR.IDPESAPROD   
            ORDER BY V.CDFILIAL, TC.CDTIPOCONS, PR.CDARVPROD
        ";
        
        $result = $this->connection->fetchAll($qry, $params);
        
        return $result;
    }
}